# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

SPEC_FILE_MERGE_METADATA = Metadata(
    id="2c5e3a5c053998c2a574a6f035a5993430771a18.boutiques",
    name="spec-file-merge",
    package="workbench",
    container_image_tag="brainlife/connectome_workbench:1.5.0-freesurfer-update",
)


SpecFileMergeParameters = typing.TypedDict('SpecFileMergeParameters', {
    "__STYX_TYPE__": typing.Literal["spec-file-merge"],
    "spec_1": str,
    "spec_2": str,
    "out_spec": str,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "spec-file-merge": spec_file_merge_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
    }.get(t)


class SpecFileMergeOutputs(typing.NamedTuple):
    """
    Output object returned when calling `spec_file_merge(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def spec_file_merge_params(
    spec_1: str,
    spec_2: str,
    out_spec: str,
) -> SpecFileMergeParameters:
    """
    Build parameters.
    
    Args:
        spec_1: first spec file to merge.
        spec_2: second spec file to merge.
        out_spec: output - output spec file.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "spec-file-merge",
        "spec_1": spec_1,
        "spec_2": spec_2,
        "out_spec": out_spec,
    }
    return params


def spec_file_merge_cargs(
    params: SpecFileMergeParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("wb_command")
    cargs.append("-spec-file-merge")
    cargs.append(params.get("spec_1"))
    cargs.append(params.get("spec_2"))
    cargs.append(params.get("out_spec"))
    return cargs


def spec_file_merge_outputs(
    params: SpecFileMergeParameters,
    execution: Execution,
) -> SpecFileMergeOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = SpecFileMergeOutputs(
        root=execution.output_file("."),
    )
    return ret


def spec_file_merge_execute(
    params: SpecFileMergeParameters,
    execution: Execution,
) -> SpecFileMergeOutputs:
    """
    Merge two spec files into one.
    
    The output spec file contains every file that is in either of the input spec
    files.
    
    Author: Connectome Workbench Developers
    
    URL: https://github.com/Washington-University/workbench
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `SpecFileMergeOutputs`).
    """
    params = execution.params(params)
    cargs = spec_file_merge_cargs(params, execution)
    ret = spec_file_merge_outputs(params, execution)
    execution.run(cargs)
    return ret


def spec_file_merge(
    spec_1: str,
    spec_2: str,
    out_spec: str,
    runner: Runner | None = None,
) -> SpecFileMergeOutputs:
    """
    Merge two spec files into one.
    
    The output spec file contains every file that is in either of the input spec
    files.
    
    Author: Connectome Workbench Developers
    
    URL: https://github.com/Washington-University/workbench
    
    Args:
        spec_1: first spec file to merge.
        spec_2: second spec file to merge.
        out_spec: output - output spec file.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `SpecFileMergeOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(SPEC_FILE_MERGE_METADATA)
    params = spec_file_merge_params(
        spec_1=spec_1,
        spec_2=spec_2,
        out_spec=out_spec,
    )
    return spec_file_merge_execute(params, execution)


__all__ = [
    "SPEC_FILE_MERGE_METADATA",
    "SpecFileMergeOutputs",
    "SpecFileMergeParameters",
    "spec_file_merge",
    "spec_file_merge_params",
]
