# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

SURFACE_VERTEX_AREAS_METADATA = Metadata(
    id="e736f9e335364be2945a738405dcb99e76c0e26b.boutiques",
    name="surface-vertex-areas",
    package="workbench",
    container_image_tag="brainlife/connectome_workbench:1.5.0-freesurfer-update",
)


SurfaceVertexAreasParameters = typing.TypedDict('SurfaceVertexAreasParameters', {
    "__STYX_TYPE__": typing.Literal["surface-vertex-areas"],
    "surface": InputPathType,
    "metric": str,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "surface-vertex-areas": surface_vertex_areas_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
        "surface-vertex-areas": surface_vertex_areas_outputs,
    }.get(t)


class SurfaceVertexAreasOutputs(typing.NamedTuple):
    """
    Output object returned when calling `surface_vertex_areas(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    metric: OutputPathType
    """the output metric"""


def surface_vertex_areas_params(
    surface: InputPathType,
    metric: str,
) -> SurfaceVertexAreasParameters:
    """
    Build parameters.
    
    Args:
        surface: the surface to measure.
        metric: the output metric.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "surface-vertex-areas",
        "surface": surface,
        "metric": metric,
    }
    return params


def surface_vertex_areas_cargs(
    params: SurfaceVertexAreasParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("wb_command")
    cargs.append("-surface-vertex-areas")
    cargs.append(execution.input_file(params.get("surface")))
    cargs.append(params.get("metric"))
    return cargs


def surface_vertex_areas_outputs(
    params: SurfaceVertexAreasParameters,
    execution: Execution,
) -> SurfaceVertexAreasOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = SurfaceVertexAreasOutputs(
        root=execution.output_file("."),
        metric=execution.output_file(params.get("metric")),
    )
    return ret


def surface_vertex_areas_execute(
    params: SurfaceVertexAreasParameters,
    execution: Execution,
) -> SurfaceVertexAreasOutputs:
    """
    Measure surface area each vertex is responsible for.
    
    Each vertex gets one third of the area of each triangle it is a part of.
    Units are mm^2.
    
    Author: Connectome Workbench Developers
    
    URL: https://github.com/Washington-University/workbench
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `SurfaceVertexAreasOutputs`).
    """
    params = execution.params(params)
    cargs = surface_vertex_areas_cargs(params, execution)
    ret = surface_vertex_areas_outputs(params, execution)
    execution.run(cargs)
    return ret


def surface_vertex_areas(
    surface: InputPathType,
    metric: str,
    runner: Runner | None = None,
) -> SurfaceVertexAreasOutputs:
    """
    Measure surface area each vertex is responsible for.
    
    Each vertex gets one third of the area of each triangle it is a part of.
    Units are mm^2.
    
    Author: Connectome Workbench Developers
    
    URL: https://github.com/Washington-University/workbench
    
    Args:
        surface: the surface to measure.
        metric: the output metric.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `SurfaceVertexAreasOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(SURFACE_VERTEX_AREAS_METADATA)
    params = surface_vertex_areas_params(
        surface=surface,
        metric=metric,
    )
    return surface_vertex_areas_execute(params, execution)


__all__ = [
    "SURFACE_VERTEX_AREAS_METADATA",
    "SurfaceVertexAreasOutputs",
    "SurfaceVertexAreasParameters",
    "surface_vertex_areas",
    "surface_vertex_areas_params",
]
