# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

VOLUME_LABEL_MODIFY_KEYS_METADATA = Metadata(
    id="f52535d3e5a2690d3eb95fcebf26bd4dfa8db089.boutiques",
    name="volume-label-modify-keys",
    package="workbench",
    container_image_tag="brainlife/connectome_workbench:1.5.0-freesurfer-update",
)


VolumeLabelModifyKeysParameters = typing.TypedDict('VolumeLabelModifyKeysParameters', {
    "__STYX_TYPE__": typing.Literal["volume-label-modify-keys"],
    "volume_in": InputPathType,
    "remap_file": str,
    "volume_out": str,
    "opt_subvolume_subvolume": typing.NotRequired[str | None],
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "volume-label-modify-keys": volume_label_modify_keys_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
        "volume-label-modify-keys": volume_label_modify_keys_outputs,
    }.get(t)


class VolumeLabelModifyKeysOutputs(typing.NamedTuple):
    """
    Output object returned when calling `volume_label_modify_keys(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    volume_out: OutputPathType
    """the output volume label file"""


def volume_label_modify_keys_params(
    volume_in: InputPathType,
    remap_file: str,
    volume_out: str,
    opt_subvolume_subvolume: str | None = None,
) -> VolumeLabelModifyKeysParameters:
    """
    Build parameters.
    
    Args:
        volume_in: the input volume label file.
        remap_file: text file with old and new key values.
        volume_out: the output volume label file.
        opt_subvolume_subvolume: select a single subvolume: the subvolume\
            number or name.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "volume-label-modify-keys",
        "volume_in": volume_in,
        "remap_file": remap_file,
        "volume_out": volume_out,
    }
    if opt_subvolume_subvolume is not None:
        params["opt_subvolume_subvolume"] = opt_subvolume_subvolume
    return params


def volume_label_modify_keys_cargs(
    params: VolumeLabelModifyKeysParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("wb_command")
    cargs.append("-volume-label-modify-keys")
    cargs.append(execution.input_file(params.get("volume_in")))
    cargs.append(params.get("remap_file"))
    cargs.append(params.get("volume_out"))
    if params.get("opt_subvolume_subvolume") is not None:
        cargs.extend([
            "-subvolume",
            params.get("opt_subvolume_subvolume")
        ])
    return cargs


def volume_label_modify_keys_outputs(
    params: VolumeLabelModifyKeysParameters,
    execution: Execution,
) -> VolumeLabelModifyKeysOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = VolumeLabelModifyKeysOutputs(
        root=execution.output_file("."),
        volume_out=execution.output_file(params.get("volume_out")),
    )
    return ret


def volume_label_modify_keys_execute(
    params: VolumeLabelModifyKeysParameters,
    execution: Execution,
) -> VolumeLabelModifyKeysOutputs:
    """
    Change key values in a volume label file.
    
    <remap-file> should have lines of the form 'oldkey newkey', like so:
    
    3 5
    5 8
    8 2
    
    This would change the current label with key '3' to use the key '5' instead,
    5 would use 8, and 8 would use 2. Any collision in key values results in the
    label that was not specified in the remap file getting remapped to an
    otherwise unused key. Remapping more than one key to the same new key, or
    the same key to more than one new key, results in an error. This will not
    change the appearance of the file when displayed, as it will change the key
    values in the data at the same time.
    
    Author: Connectome Workbench Developers
    
    URL: https://github.com/Washington-University/workbench
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `VolumeLabelModifyKeysOutputs`).
    """
    params = execution.params(params)
    cargs = volume_label_modify_keys_cargs(params, execution)
    ret = volume_label_modify_keys_outputs(params, execution)
    execution.run(cargs)
    return ret


def volume_label_modify_keys(
    volume_in: InputPathType,
    remap_file: str,
    volume_out: str,
    opt_subvolume_subvolume: str | None = None,
    runner: Runner | None = None,
) -> VolumeLabelModifyKeysOutputs:
    """
    Change key values in a volume label file.
    
    <remap-file> should have lines of the form 'oldkey newkey', like so:
    
    3 5
    5 8
    8 2
    
    This would change the current label with key '3' to use the key '5' instead,
    5 would use 8, and 8 would use 2. Any collision in key values results in the
    label that was not specified in the remap file getting remapped to an
    otherwise unused key. Remapping more than one key to the same new key, or
    the same key to more than one new key, results in an error. This will not
    change the appearance of the file when displayed, as it will change the key
    values in the data at the same time.
    
    Author: Connectome Workbench Developers
    
    URL: https://github.com/Washington-University/workbench
    
    Args:
        volume_in: the input volume label file.
        remap_file: text file with old and new key values.
        volume_out: the output volume label file.
        opt_subvolume_subvolume: select a single subvolume: the subvolume\
            number or name.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `VolumeLabelModifyKeysOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(VOLUME_LABEL_MODIFY_KEYS_METADATA)
    params = volume_label_modify_keys_params(
        volume_in=volume_in,
        remap_file=remap_file,
        volume_out=volume_out,
        opt_subvolume_subvolume=opt_subvolume_subvolume,
    )
    return volume_label_modify_keys_execute(params, execution)


__all__ = [
    "VOLUME_LABEL_MODIFY_KEYS_METADATA",
    "VolumeLabelModifyKeysOutputs",
    "VolumeLabelModifyKeysParameters",
    "volume_label_modify_keys",
    "volume_label_modify_keys_params",
]
